#ifndef _SDG_ERROR_H_
#define _SDG_ERROR_H_

/* * * Sdg_Error.h * * *
顼饹ꥹ
* * * * * * * * * * */

#include"Sdg_Head.h"

//throwѥ饹ꥹ
namespace Sdg_Error{
	//顼Ѵ쥯饹
	class BaseError{
	public:
		BaseError():msg("Unknown error!!"),error_name("Unknown"){}
		BaseError(std::string name,std::string message)
			:msg(error_name),error_name(name){}
		virtual void ErrorPrint(std::ostream &os) const;
		virtual ~BaseError(){}
	protected:
		std::string msg;
		std::string error_name;
	};
	//X11¸顼
	class X11OnlyError: public BaseError{
	public:
		X11OnlyError(std::string error_message)
			:BaseError("X11",error_message){}
	};
	//ץȤα黻顼
	class ScriptOperationError: public BaseError{
	public:
		ScriptOperationError(std::string error_message)
			:BaseError("Operation",error_message){}
	};
	//ץȤβϥ顼
	class ParserError: public BaseError{
	public:
		ParserError(int line,char *message)
			:BaseError("Parser",message),line_num(line){}
		void ErrorPrint(std::ostream &os) const;
	protected:
		int line_num;
	};
};
//BaseError
std::ostream& operator<<(std::ostream &os,const Sdg_Error::BaseError &b);


//ٹå
//cerr << Sdg_Warning_Message << "Warning message..."; ȻȤ
const std::string Sdg_Warning_Message = "Script de GUI Warning:\n\t";

#endif
