#ifndef _SDG_WIDGET_H_
#define _SDG_WIDGET_H_

/* * * Sdg_Widget.h * * *
ƤΥåȤδܥ饹
* * * * * * * * * * * * */

#include"Sdg_Head.h"
//Ķ˰¸إå
//ѥŬڤʥǥ쥯ȥꤷƤ
#include"Sdg_Sys_Widget.h"

//Υ饹
class Sdg_Color{
	sdg_u8 r,g,b;
	//Υԥ
	sdg_u32 pixel; 
 public:
	//ο
	Sdg_Color(sdg_u8 red,sdg_u8 green,sdg_u8 blue);
	//ꤵ줿֤
	sdg_u8 Red(void) const {return r;}
	sdg_u8 Green(void) const {return g;}
	sdg_u8 Blue(void) const {return b;}
};

//åȤΥꥹ
enum Sdg_Widget_Type{
	INVALID_WIDGET,
	SDG_WINDOW,
	SDG_PIXMAP,
	SDG_BUTTON,
};

//åȤδܤΥ饹
class Sdg_Widget{
 public:

	//åȤκ
	//,ƥå(ʤʤNULL),ɽ,,٥ȥޥ
	Sdg_Widget(Sdg_Widget *parent,sdg_u16 x,sdg_u16 y,
		   sdg_u16 width,sdg_u16 height,sdg_u32 mask);
	//åȤκ
	virtual ~Sdg_Widget();

	//ɽ
	void Map(void);
	//
	void Unmap(void);
	//ѹ(0ξ̵ѹ)
	void Resize(sdg_u16 x,sdg_u16 y,sdg_u16 width,sdg_u16 height);

	//åȤΥפ֤
	virtual Sdg_Widget_Type WidgetType(void) const {return INVALID_WIDGET;}

	//٥Ȥɲä
	void AddEvent(sdg_u32 mask);
 protected:
	//,ʤNULL
	Sdg_Widget *parent; 
	//Ķ˰¸ѿ
	//䥦ɥIDʤ(Sdg_Sys_Widget.h)
	Sdg_Sys_Widget *sys; 
	//٥ȤΥޥ
	sdg_u32 event_mask; 

	//ΥåȺ
	Sdg_Widget();
};

#endif /*_SDG_WIDGET_H_*/
