/* * * Sdg_Script.cpp * * *
ץȤΥɤ򤹤륯饹
* * * * * * * * * * * * * */

#include"Sdg_Script.h"
#include"Sdg_Yacc.tab.h"
#include<stdio.h>

using namespace std;

extern int parse_start(sdg_u8 *data);

static Sdg_Script_Block *root_block; //ץƤΥ롼

/*----- ץȤΥ饹 -----*/
/* * * ץȤΥ * * */
Sdg_Script::Sdg_Script(const string file_name): f_name(file_name)
{
	FILE *fp;

	//եΥץ
	fp = fopen(&f_name[0],"r");
	if(fp == NULL)
		throw Sdg_Error::ParserError(0,"Load error");

	//եΥĴ٤
	int file_size;
	fseek(fp,0,SEEK_END);
	file_size = ftell(fp);
	rewind(fp);

	//եΥ
	int c,i;
	script_data = new sdg_u8[file_size];
	for(i=0; ((c = fgetc(fp)) != EOF); i++)
		script_data[i] = c;
	script_data[i] = '\0';
	fclose(fp);

	//롼ȤˤΥץȤĤʤ
	script_block = new Sdg_Script_Block(root_block);

	//ʸ
	parse_start(script_data);
}

/* * * ץȤκ * * */
Sdg_Script::~Sdg_Script()
{
	//ǡβ
	delete script_block;
	delete script_data;
}

/* * * ؿμ¹ * * */
void Sdg_Script::Call(string func_name)
{
	//̤
}

/* * * ѿΥå * * */
void Sdg_Script::SetVariable(string &var_name,Sdg_Variable_Data var)
{
	Sdg_Variable v(var_name,var);

	script_block->Add(v);
}

/* * * ѿθ * * */
Sdg_Variable *Sdg_Script::GetVariable(string var_name)
{
	return script_block->Search(var_name);
}

/* * * ץȥ饹Τν * * */
void Sdg_Script_Init(void)
{
	root_block = new Sdg_Script_Block(NULL);
}
