#ifndef _SDG_EVENT_H_
#define _SDG_EVENT_H_

/* * * Sdg_Event.h * * *
٥ȥ饹
* * * * * * * * * * * */

#include"Sdg_Head.h"
#include"Sdg_Widget.h"
class Sdg_Widget;

//Υꥹ
#include"Sdg_Keylist.h"

//٥ȥޥ
enum{
	SDG_NO_EVENT = 0,
	SDG_KEY_PRESS = (1<<1),
	SDG_KEY_RELEASE = (1<<2),
	SDG_BUTTON_PRESS = (1<<3),
	SDG_BUTTON_RELEASE = (1<<4),
	SDG_REPAINT = (1<<5),
	SDG_DESTROY = (1<<6),
};

//̥ǡ
struct Sdg_Union_Data{
	sdg_u32 type; //ȯ٥ȤΥޥ
	Sdg_Widget *wid; //٥Ȥȯå
};

//ܡɥ٥
struct Sdg_Key_Event: public Sdg_Union_Data{
	sdg_u32 key; //줿
	sdg_u32 mask; //˲Ƥ(ե,ȥ)
};

//ܥ(ޥ)٥
struct Sdg_Button_Event: public Sdg_Union_Data{
	sdg_u16 x,y; //줿
	sdg_u8 button; //줿ܥ(=1,=2,=3)
};

//襤٥
struct Sdg_Repaint_Event: public Sdg_Union_Data{
	sdg_u16 width,height; //Ѥ줿ȤθߤΥ
};

//λ٥(Хĥܥ򲡤ʤ)
struct Sdg_Destroy_Event: public Sdg_Union_Data{
};

//٥ȶ
union Sdg_Event_Data{
	Sdg_Button_Event button;
	Sdg_Key_Event key;
	Sdg_Repaint_Event repaint;
	Sdg_Destroy_Event destroy;
	Sdg_Union_Data data;
};

//٥ȥ饹
class Sdg_Event{
 public:
	//
	Sdg_Event();
	//õ
	~Sdg_Event();

	//٥ȤȯޤԤ
	//٥ȤΥޥ֤
	sdg_u32 Wait(void);
	//٥ȤȯƤ뤫Ĵ٤
	//٥ȤΥޥ֤(ʤСSDG_NO_EVENT)
	sdg_u32 Check(void);
	//٥ȶΤ֤
	Sdg_Event_Data *Data(void);
 private:
	Sdg_Event_Data event_data;
};

#endif /*_SDG_EVENT_H_*/
