%{
/* * * Sdg_Yacc.y * * *
ʸϴؿ
* * * * * * * * * * * */

#include"Sdg_Head.h"
#include"Sdg_Error.h"
#include"Sdg_Variable.h"

static int line_num;

//ץȤΥǡ
extern sdg_u8 *script_data;
//ϴؿ
int yylex(void);
//顼ϴؿ
void yyerror(char *msg);

#undef YYSTYPE
#define YYSTYPE yyparse_type

%}

%token Y_NUMBER
%token Y_STRING
%token Y_IDENTIFY
%left '+' '-'
%left '*' '/' '%'
%right U_MINUS

%%

input: /*null*/
	| input line 
	;

line: '\n'	{line_num++;}
	| var_expr '\n' {std::cout << Sdg_Variable("ans",$1.var);line_num++;}
	;

var_expr: Y_NUMBER	{$$.var = $1.var;}
	| Y_STRING	{$$.var = $1.var;}
	| var_expr '+' var_expr {$$.var = $1.var + $3.var;}
	| var_expr '-' var_expr {$$.var = $1.var - $3.var;}
	| var_expr '*' var_expr {$$.var = $1.var * $3.var;}
	| var_expr '/' var_expr {$$.var = $1.var / $3.var;}
	| var_expr '%' var_expr {$$.var = $1.var % $3.var;}
	| '(' var_expr ')' {$$.var = $2.var;}
	| '-' var_expr %prec U_MINUS {$$.var = $2.var * (-1);}
	;

%%

/* * * ϴؿΥ顼 * * */
void yyerror(char *msg)
{
	throw Sdg_Error::ParserError(line_num,msg);
}

/* * * ץȤμ¹ * * */
int parse_start(sdg_u8 *data)
{
	script_data = data;
	return yyparse();
}
