/* * * Sdg_Application.cpp * * *
Sdg_Applicationμ
* * * * * * * * * * * * * * * */

#include"Sdg_Head.h"
#include"Sdg_Error.h"
#include"Sdg_Application.h"
#include"Sdg_Variable.h"
#include"Extern.h"

/*----- Sdgν饹 -----*/
/* * *  * * */
Sdg_Application::Sdg_Application(int argc,char **argv)
{
	/*ǥץ쥤Υץ*/
	display = XOpenDisplay(NULL);
	if(display == NULL)
		throw Sdg_Error::X11OnlyError("Can't open Display");
	/*Extern*/
	root_window = DefaultRootWindow(display);
	colormap = DefaultColormap(display,0);
	/*¸ǡκ*/
	sys = new Sdg_Sys_Application;
	/**/
	XSetCommand(display,root_window,argv,argc);
	/*ץȤν*/
	Sdg_Script_Init();
}

/* * * λ * * */
Sdg_Application::~Sdg_Application()
{
	/*¸ǡκ*/
	delete sys;
	/*ǥץ쥤Υ*/
	XCloseDisplay(display);
}

/* * * ¹ԴĶ֤ * * */
Sdg_Running_Mode Sdg_Application::RunningMode(void)
{
	return SDG_FOR_X11;
}
